<?

/*

 	Webmedia Explorer 5.0 - Multimedia Management System
 	Copyright (C) 2007 Marc Salmurri (marc.salmurri@gmail.com)

 	This program is free software; you can redistribute it and/or modify
 	it under the terms of the GNU General Public License as published by
 	the Free Software Foundation; either version 2 of the License, or (at
 	your option) any later version.

 	This program is distributed in the hope that it will be useful, but
 	WITHOUT ANY WARRANTY; without even the implied warranty of
 	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 	General Public License for more details.

 	You should have received a copy of the GNU General Public License
 	along with this program; if not, write to the Free Software
 	Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA  02110-1301, USA.

*/

	error_reporting ( E_ERROR );

	include ( "conf/config.lib.php" );

	include ( $path_include."core.lib.php" );

	// ------------------------------------------------------------------	

	$folder = new folder ();

	$GLOBALS["dir"] = $folder->clean_link ( $_GET["dir"] );

	if ( !$folder->folder_path ( $GLOBALS["dir"] ) ) exit;
	
	if ( ( $_GET["max"] <= 0 ) || ( $_GET["max"] > 2000 ) ) exit;

	$image = new image ();

	if ( !$image->image_path ( $GLOBALS["dir"], $_GET["image"], 1 ) ) exit;

	$data = _create_thumb ( $folder->get ( "path" ), $_GET["image"], $_GET["max"] );

	// Grab all the HTTP headers since If-None-Match and If-Modified-Since are not grabbed by the globals

	$headers = request_headers ();

	// Check the If-None-Match and If-Modified-Since headers

	if ( ( strpos ( $headers['If-None-Match'], 'image-'.$data["md5"].'' ) ) && ( gmstrftime ( "%a, %d %b %Y %T %Z", filemtime ( $data["cache_file"] ) ) == $headers['If-Modified-Since'] ) )
	{
		header ( 'HTTP/1.1 304 Not Modified' );			// They already have the most up to date copy of the image so tell them

		header ( "Cache-Control: private" );			// Change php's default caching mechanisms turning off the no-cache pragma, expires and content-type header

		header ( "Pragma: " );

		header ( "Expires: " );

		header ( "Content-Type: " );

		header ( 'ETag: "image-'.$data["md5"].'"' );	// The Etag must be enclosed with double quotes

		exit ();

	} else {

		// They need a new copy of the image so open it up

		header ( "Content-Type: image/jpeg" );

		header ( "Content-Length: ".filesize ( $data["cache_file"] ) );

		header ( "Cache-Control: private" );			// Change php's default caching mechanisms turning off the no-cache pragma, expires and content-type header

		header ( "Pragma: " );

		header ( "Expires: " );

		// Send the browser the last modified date and etag so they can cache it

		header ( "Last-Modified: ".gmstrftime ( "%a, %d %b %Y %T %Z", filemtime ( $data["cache_file"] ) ) );

		header ( 'ETag: "image-'.$data["md5"].'"' );

		// Dump all the image data back to the browser

		$img = imagecreatefromjpeg ( $data["cache_file"] );

		imagejpeg ( $img );
	}

?>